SystemOrganization addCategory: #'GT-Debugger-EventRecorder'!
SystemOrganization addCategory: 'GT-Debugger-EventRecorder-Base'!
SystemOrganization addCategory: 'GT-Debugger-EventRecorder-Events'!

!GTGoAndInspectBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGoAndInspectBytecodeEvent fromDebugAction: self! !

!GTStepToBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderStepToBytecodeEvent fromDebugAction: self! !

!GTDebuggerBrowserUpdateRequest methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/29/2016 14:13'!
asRecorderEvent

	^ debugActionExecutedAnnouncement asRecorderEvent! !

!DebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:43'!
asRecorderEvent

	^ GTDebuggerRecorderDebugActionEvent fromDebugAction: self! !

!GTGenericStackDebuggerSelectionChanged methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:44'!
asRecorderEvent

	^ GTDebuggerRecorderStackSelectionChangedEvent fromAnnouncement: self! !

!RunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderRunToSelectionEvent fromDebugAction: self! !

!GLMBrowserClosing methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:45'!
asRecorderEvent

	^ GTDebuggerRecorderClosingEvent fromAnnouncement: self! !

!GTChangeDebuggerAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:48'!
asRecorderEvent

	^ GTDebuggerRecorderChangeDebuggerEvent fromDebugAction: self! !

!GTChangeDebuggerAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/31/2016 13:59'!
debuggerClass

	^ debuggerClass! !

!GTGlamourWrapperDebuggingAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGlamourWrapperEvent fromDebugAction: self! !

GTEventCollector subclass: #GTDebuggerEventCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Base'!

!GTDebuggerEventCollector commentStamp: 'RogerStebler 3/18/2016 16:04' prior: 0!
I represent a GTEventCollector for GTDebugger application.!

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/22/2016 21:58'!
collectDataFrom: aDebugger
	self occupant: aDebugger;
		category: #gtdebugger;
		register;
		linkToDebugger: aDebugger;
		recordDebuggerOpenEventFor: aDebugger.
		
	aDebugger announcer announce: (GTGenericStackDebuggerSelectionChanged forDebugger: aDebugger).! !

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/28/2016 15:10'!
linkToDebugger: aDebugger

	aDebugger announcer weak when: Announcement send: #recordAnnouncementIgnoreExecuted: to: self! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/18/2016 15:46'!
recordAnnouncement: anAnnouncement
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		event := anAnnouncement asRecorderEvent.
		self add: event.
		GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event). ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/28/2016 15:10'!
recordAnnouncementIgnoreExecuted: anAnnouncement
	(anAnnouncement class ~= DebugActionExecuted) ifTrue: [ self recordAnnouncement: anAnnouncement ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/18/2016 15:46'!
recordDebuggerOpenEventFor: aDebugger
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	event := GTDebuggerRecorderOpenEvent new fromDebugger: aDebugger.
	self add: event.
	GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event).! !

!ResumeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/30/2016 13:30'!
asRecorderEvent

	^ GTDebuggerRecorderResumeEvent fromDebugAction: self! !

Announcement subclass: #GTDebuggerRecorderEventRecorded
	instanceVariableNames: 'recordedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Base'!

!GTDebuggerRecorderEventRecorded commentStamp: 'RogerStebler 3/18/2016 16:26' prior: 0!
I am an event that is sent after an action in the debugger was recorded.!

!GTDebuggerRecorderEventRecorded class methodsFor: 'instance creation' stamp: 'RogerStebler 3/1/2016 17:48'!
forEvent: aRecorderEvent
	^ self new
		recordedEvent: aRecorderEvent;
		yourself.! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent
	^ recordedEvent! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent: aRecorderEvent
	recordedEvent := aRecorderEvent! !

!GTRunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGTRunToSelectionEvent fromDebugAction: self! !

!MessageSendDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderMessageSendEvent fromDebugAction: self! !

!DebugActionExecuted methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: true;
		yourself! !

Object subclass: #GTDebuggerRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderEvent commentStamp: 'RogerStebler 3/18/2016 16:28' prior: 0!
I am the root class for representing usage data generated by GTDebugger. 
All events have a timestamp.!

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderClosingEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderClosingEvent commentStamp: 'RogerStebler 3/18/2016 16:29' prior: 0!
I model the action of closing the debugger.!

!GTDebuggerRecorderClosingEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/15/2016 16:10'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self addWindowHashFor: anAnnouncement presentation.! !

!GTDebuggerRecorderClosingEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:26'!
isCloseDebugger
	^ true! !

!GTDebuggerRecorderClosingEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:51'!
windowHash
	^ self infoAt: #windowHash! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderDebugActionEvent
	instanceVariableNames: 'isExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderDebugActionEvent commentStamp: 'RogerStebler 3/18/2016 16:31' prior: 0!
I model the debugging actions in the debugger.!

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderChangeDebuggerEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderChangeDebuggerEvent commentStamp: 'RogerStebler 3/18/2016 16:50' prior: 0!
I model the debugging action of changing the debugger (e.g. stack debugger <-> bytecode debugger).

Corresponding debug action:
GTChangeDebuggerAction!

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'private' stamp: 'RogerStebler 3/5/2016 16:02'!
addNewWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #newWindowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:45'!
debuggerClass
	^ self infoAt: #debuggerClass! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/31/2016 14:00'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #debuggerClass put: aDebugAction debuggerClass name.
	aDebugAction newDebugger isNotNil ifTrue: [ self addNewWindowHashFor: aDebugAction newDebugger ]! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 16:44'!
isChangeDebugger
	^ true! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:46'!
newWindowHash
	^ self infoAt: #newWindowHash! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderCodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderCodeDebugActionEvent commentStamp: 'RogerStebler 3/18/2016 16:45' prior: 0!
I model the debugging action of selecting an action in the code pane of the debugger.

Corresponding debug action:
GTCodeDebugAction!

!GTDebuggerRecorderCodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 4/7/2016 13:55'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selectionInterval put: aDebugAction codePresentation selectionInterval.! !

!GTDebuggerRecorderCodeDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:59'!
selectionInterval
	^ self infoAt: #selectionInterval! !

!GTDebuggerRecorderDebugActionEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:52'!
fromDebugAction: aDebugAction

	^ self new fromDebugAction: aDebugAction! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:47'!
debugActionClass
	^ self infoAt: #debugActionClass! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'initialization' stamp: 'AndreiChis 3/23/2016 14:49'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	self infoAt: #methodClass putHashForText: aDebugAction currentContext methodClass name.
	self infoAt: #methodSelector putHashForText: aDebugAction currentContext methodSelector.
	self infoAt: #pc put: aDebugAction currentContext pc.
	self infoAt: #nextInstruction putHashForText: aDebugAction currentContext peekInstruction asString.
	self addWindowHashFor: aDebugAction debugger.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/5/2016 15:17'!
isAboutToExectute
	^ self isExecuted not! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 17:11'!
isDebugAction
	^ true! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted
	^ isExecuted! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted: aBoolean
	isExecuted := aBoolean! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:47'!
methodClass
	^ self infoAt: #methodClass! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:47'!
methodSelector
	^ self infoAt: #methodSelector! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:48'!
nextInstruction
	^ self infoAt: #nextInstruction! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:48'!
pc
	^ self infoAt: #pc! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:49'!
windowHash
	^ self infoAt: #windowHash! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGTRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGTRunToSelectionEvent commentStamp: 'RogerStebler 3/18/2016 16:46' prior: 0!
I model the Run To Selection debugging action in a GTDebugger.

Corresponding debug action:
GTRunToSelectionDebugAction!

!GTDebuggerRecorderGTRunToSelectionEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:32'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selectionInterval put: aDebugAction debugger selectionInterval.! !

!GTDebuggerRecorderGTRunToSelectionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:59'!
selectionInterval
	^ self infoAt: #selectionInterval! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGlamourWrapperEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGlamourWrapperEvent commentStamp: 'RogerStebler 3/18/2016 16:52' prior: 0!
I model the wrapped glamour actions in a GTDebugger.

Corresponding debug action:
GTGlamourWrapperDebuggingAction!

!GTDebuggerRecorderGlamourWrapperEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:32'!
fromDebugAction: aDebugAction
	self flag: 'Find a better way to get type of action'.
	super fromDebugAction: aDebugAction.
	self infoAt: #glamourActionTitle put: aDebugAction asGlamourAction title.
	self infoAt: #selectionInterval put: aDebugAction debugger selectionInterval.! !

!GTDebuggerRecorderGlamourWrapperEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:00'!
glamourActionTitle
	^ self infoAt: #glamourActionTitle! !

!GTDebuggerRecorderGlamourWrapperEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:00'!
selectionInterval
	^ self infoAt: #selectionInterval! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGoAndInspectBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGoAndInspectBytecodeEvent commentStamp: 'RogerStebler 3/18/2016 16:54' prior: 0!
I model the Go and Inspect debugging action in a GTBytecodeDebugger.

Corresponding debug action:
GTGoAndInspectBytecodeDebugAction!

!GTDebuggerRecorderGoAndInspectBytecodeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:00'!
bytecodePosition
	^ self infoAt: #bytecodePosition! !

!GTDebuggerRecorderGoAndInspectBytecodeEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:43'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selectionInterval put: aDebugAction debugger bytecodePresentation selection sourceInterval.
	self infoAt: #bytecodePosition put: (aDebugAction debugger currentContext method symbolicBytecodes
		indexOf: aDebugAction debugger bytecodePresentation selection ifAbsent: [-1]).! !

!GTDebuggerRecorderGoAndInspectBytecodeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:00'!
selectionInterval
	^ self infoAt: #selectionInterval! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderMessageSendEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderMessageSendEvent commentStamp: 'RogerStebler 3/18/2016 16:57' prior: 0!
I model the debugging actions that send a message to a receiver in the debugger.

Corresponding debug action:
MessageSendDebugAction!

!GTDebuggerRecorderMessageSendEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:24'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selector put: aDebugAction selector.! !

!GTDebuggerRecorderMessageSendEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:01'!
selector
	^ self infoAt: #selector! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderResumeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderResumeEvent commentStamp: 'RogerStebler 3/30/2016 13:18' prior: 0!
I model the Proceed debugging action in a debugger.

Corresponding debug action:
ResumeDebugAction!

!GTDebuggerRecorderResumeEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/30/2016 13:28'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	aDebugAction currentContext isDead ifFalse: [
		self infoAt: #methodClass putHashForText: aDebugAction currentContext methodClass name.
		self infoAt: #methodSelector putHashForText: aDebugAction currentContext methodSelector.
		self infoAt: #pc put: aDebugAction currentContext pc.
		self infoAt: #nextInstruction putHashForText: aDebugAction currentContext peekInstruction asString ].
	self addWindowHashFor: aDebugAction debugger.! !

!GTDebuggerRecorderResumeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:02'!
methodClass
	^ self infoAt: #methodClass ifAbsent: [ nil ]! !

!GTDebuggerRecorderResumeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:03'!
methodSelector
	^ self infoAt: #methodSelector ifAbsent: [ nil ]! !

!GTDebuggerRecorderResumeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:03'!
nextInstruction
	^ self infoAt: #nextInstruction ifAbsent: [ nil ]! !

!GTDebuggerRecorderResumeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:03'!
pc
	^ self infoAt: #pc ifAbsent: [ nil ]! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderRunToSelectionEvent commentStamp: 'RogerStebler 3/18/2016 16:47' prior: 0!
I model the Run To Selection debugging action in a debugger.

Corresponding debug action:
RunToSelectionDebugAction!

!GTDebuggerRecorderRunToSelectionEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:33'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selectionInterval put: aDebugAction debugger code getSelection.! !

!GTDebuggerRecorderRunToSelectionEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:04'!
selectionInterval
	^ self infoAt: #selectionInterval! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderStepToBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderStepToBytecodeEvent commentStamp: 'RogerStebler 3/18/2016 16:59' prior: 0!
I model the Step to bytecode debugging action in a GTBytecodeDebugger.

Corresponding debug action:
GTStepToBytecodeDebugAction!

!GTDebuggerRecorderStepToBytecodeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:05'!
bytecodePosition
	^ self infoAt: #bytecodePosition! !

!GTDebuggerRecorderStepToBytecodeEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:43'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selectionInterval put: aDebugAction debugger bytecodePresentation selection sourceInterval.
	self infoAt: #bytecodePosition put: (aDebugAction debugger currentContext method symbolicBytecodes
		indexOf: aDebugAction debugger bytecodePresentation selection ifAbsent: [-1]).! !

!GTDebuggerRecorderStepToBytecodeEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 17:04'!
selectionInterval
	^ self infoAt: #selectionInterval! !

!GTDebuggerRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTDebuggerRecorderEvent methodsFor: 'comparing' stamp: 'RogerStebler 4/1/2016 17:14'!
= otherGTDebuggerRecorderEvent

	^ self class == otherGTDebuggerRecorderEvent class
	  and: [ self info = otherGTDebuggerRecorderEvent info ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 15:36'!
addWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:42'!
announcementTimestamp
	^ self infoAt: #timestamp ifAbsent: [ self timestamp ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:40'!
computerUUID
	^ self infoAt: #computerUUID ifAbsent: [ GlobalIdentifier uniqueInstance computerUUID asString ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:45'!
eventRecorderVersion
	^ self infoAt: #eventRecorderVersion ifAbsent: [ GTEventPacking new version ]! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement
! !

!GTDebuggerRecorderEvent methodsFor: 'comparing' stamp: 'RogerStebler 3/18/2016 18:34'!
hash
	^ self info hash! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:42'!
hashForText: aString
	^ self settings obfuscateIfNecessary: aString! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:46'!
imageHash
	^ self infoAt: #imageHash ifAbsent: [ SmalltalkImage current imagePath hash ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:46'!
imageVersion
	^ self infoAt: #imageVersion ifAbsent: [ SystemVersion current version ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/18/2016 18:28'!
info
	^ info ifNil: [ info := Dictionary new ].! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/3/2016 17:21'!
infoAt: aSymbol
	^ info at: aSymbol! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsentPut: putBlock
	info ifNil: [ info := Dictionary new ].
	^ info at: key ifAbsentPut: putBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifPresent: presentBlock ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifPresent: presentBlock ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 14:42'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:43'!
infoAt: key putHashForText: valueString 
	^ self 
		infoAt: key 
		put: (self hashForText: valueString)! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/10/2016 18:04'!
initialize
	super initialize.
	timestamp := DateAndTime now.! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:16'!
initializeObfuscated
	self obfuscated: Privacy sendEntityNames not.! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 16:43'!
isChangeDebugger
	^ false! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:26'!
isCloseDebugger
	^ false! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 17:11'!
isDebugAction
	^ false! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 16:07'!
isDebuggerEvent
	^ true! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:25'!
isOpenDebugger
	^ false! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:25'!
isOpenOrCloseDebugger
	^ self isOpenDebugger or: [ self isCloseDebugger ]! !

!GTDebuggerRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:49'!
isStackSelectionChange
	^ false! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:47'!
latestUpdate
	^ self infoAt: #latestUpdate ifAbsent: [ SystemVersion current highestUpdate ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated
	^ self infoAt: #obfuscated ifAbsent: true! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated: aBoolean
	^ self infoAt: #obfuscated put: aBoolean! !

!GTDebuggerRecorderEvent methodsFor: 'accessing - announcement info' stamp: 'RogerStebler 4/13/2016 15:47'!
sessionCreationTime
	^ self infoAt: #sessionCreationTime ifAbsent: [ SmalltalkImage current session creationTime ]! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:51'!
settings
	^ GlobalIdentifier uniqueInstance! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/10/2016 18:05'!
timestamp
	^ timestamp! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderOpenEvent commentStamp: 'RogerStebler 3/18/2016 16:30' prior: 0!
I model the action of opening the debugger.!

!GTDebuggerRecorderOpenEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:49'!
fromDebugger: aDebugger

	^ self new fromDebugger: aDebugger! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/22/2016 21:13'!
addSourceFor: aDebugger
	(Privacy sendSourceCode and: [ self isTitleAKernelException: aDebugger title ]) ifTrue: [ self infoAt: #source put: aDebugger currentContext sourceCode ].! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/22/2016 20:56'!
addTitleFor: aDebugger
	(Privacy sendEntityNames or: [ self isTitleAKernelException: aDebugger title ]) ifTrue: [ self infoAt: #title put: aDebugger title ].! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:56'!
debuggerClass
	^ self infoAt: #debuggerClass! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/22/2016 21:12'!
fromDebugger: aDebugger

	self infoAt: #debuggerClass put: aDebugger class name.
	self addWindowHashFor: aDebugger.
	self addTitleFor: aDebugger.
	self addSourceFor: aDebugger.! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:48'!
initialize
	super initialize.
	self initializeObfuscated.! !

!GTDebuggerRecorderOpenEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:26'!
isOpenDebugger
	^ true! !

!GTDebuggerRecorderOpenEvent methodsFor: 'private' stamp: 'RogerStebler 3/22/2016 21:09'!
isTitleAKernelException: aString
	^ (#Kernel asPackage classTagNamed: #Exceptions) classes anySatisfy: [ :e | e name == aString asSymbol ]! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:54'!
source
	^ self infoAt: #source ifAbsent: [ nil ]! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:54'!
title
	^ self infoAt: #title ifAbsent: [ nil ]! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:53'!
windowHash
	^ self infoAt: #windowHash! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderStackSelectionChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderStackSelectionChangedEvent commentStamp: 'RogerStebler 3/18/2016 16:30' prior: 0!
I model the action of changing the selection in the stack pane of the debugger.!

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'initialization' stamp: 'AndreiChis 4/5/2016 11:46'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self infoAt: #methodClass putHashForText: anAnnouncement newContext methodClass name.
	self infoAt: #methodSelector putHashForText: anAnnouncement newContext methodSelector.
	self infoAt: #pc put: anAnnouncement newContext pc.
	self infoAt: #stackPosition put: (anAnnouncement debugger session stack indexOf: anAnnouncement newContext ifAbsent: [-1]).
	"self infoAt: #nextInstruction putHashForText: anAnnouncement newContext peekInstruction asString."
	self addWindowHashFor: anAnnouncement debugger.! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'testing' stamp: 'RogerStebler 4/13/2016 15:49'!
isStackSelectionChange
	^ true! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:57'!
methodClass
	^ self infoAt: #methodClass! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:57'!
methodSelector
	^ self infoAt: #methodSelector! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:57'!
pc
	^ self infoAt: #pc! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:58'!
stackPosition
	^ self infoAt: #stackPosition! !

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'accessing' stamp: 'RogerStebler 4/13/2016 16:58'!
windowHash
	^ self infoAt: #windowHash! !

!GTCodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:47'!
asRecorderEvent

	^ GTDebuggerRecorderCodeDebugActionEvent fromDebugAction: self! !

!DebugActionAboutToExecute methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: false;
		yourself! !
